<!DOCTYPE html>

<html xmlns:th="http://www.thymeleaf.org" lang="en">
    <head>
        <meta charset="UTF-8"/>
        <title>Web Service and Web Sockets Demo</title>
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/css/materialize.min.css"/>
        <style>
            .feature {
                text-align: center;
            }
        </style>
    </head>
    <body>
        <div class="container">
            <h1>Web Service and Web Sockets Demo</h1>
            <p class="flow-text">
                This demonstration program shows how to build a SOAP Web Service and low-level WebSockets in Spring.
                Spring boot is used with an in-memory H2 database to support data repositories.
            </p>
            <div class="col m12 feature">
                <a th:href="${#mvc.url('AC#animalList').build()}" class="btn">List of animals</a>
            </div>
            <h4>SOAP Web Service</h4>
            <div class="row">
                <div class="col m12 feature">
                    <a th:href="@{/api/soap/animals.wsdl}" class="btn">Web service WSDL</a>
                </div>
            </div>
            <h4>WebSocket</h4>
            <div class="row">
                <div class="col offset-m3 m6">
                    <div class="card blue-grey darken-1">
                        <div class="card-content white-text">
                            <span class="card-title" id="animalName">{{NAME}}</span>
                            <div class="row">
                                <div class="col m3">Age</div>
                                <div class="col m9" id="animalAge">{{AGE}}</div>
                            </div>
                            <div class="row">
                                <div class="col m3">Type</div>
                                <div class="col m9" id="animalType">{{TYPE}}</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <script src="http://code.jquery.com/jquery-3.2.1.min.js" integrity="sha256-hwg4gsxgFZhOsEEamdOYGBf13FyQuiTwlAQgxVSNgt4=" crossorigin="anonymous"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/js/materialize.min.js"></script>
        <script>
            let ws = new WebSocket('ws://localhost:8080/animal/ticker');
            ws.addEventListener('open', e => {
                console.log('Connected to websocket');
                ws.send("Hello World");

                ws.addEventListener("message", e => {
                    let animal = JSON.parse(e.data);
                    $("#animalName").text(animal.name);
                    $("#animalAge").text(animal.age);
                    $("#animalType").text(animal.type);
                });
            });

            ws.addEventListener('error', e => {
                console.log('Error connecting to websocket', e);
            });
        </script>
    </body>
</html>